<?php
/*
 * <name>mi_acymailing</name>
 * <creationDate>September 2010</creationDate>
 * <version>1.2.0</version>
 * <author>Acyba</author>
 * <authorEmail>dev@acyba.com</authorEmail>
 * <authorUrl>http://www.acyba.com</authorUrl>
 * <copyright>Copyright (C) 2009 ACYBA SARL - All rights reserved.</copyright>
 * <license>http://www.gnu.org/licenses/gpl-2.0.html GNU/GPL</license>
 */
// Dont allow direct linking
defined('_JEXEC') OR defined( '_VALID_MOS' ) OR die( 'Direct Access to this location is not allowed.' );

class mi_acymailing
{
	function Info()
	{
		$info = array();
		$info['name'] = 'AcyMailing';
		$info['desc'] = 'Subscribe the user to AcyMailing lists';

		return $info;
	}

	function Settings()
	{
		$settings = array();

		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php')){
			echo 'This module can not work without the AcyMailing Component';
			return $settings;
		};

		$listClass = acymailing::get('class.list');
		$allLists = $listClass->getLists();

		$listsValues = array();
		foreach($allLists as $oneList){
			$listsValues[] = JHTML::_('select.option', $oneList->listid, $oneList->listid.' : '.$oneList->name );
		}

		$settings['sublists'] = array( 'list','[Activation] Subscribe the user to the selected lists','Select the lists you want the user to be subscribed to on plan activation' );
		$settings['unsublists'] = array( 'list','[Activation] Remove the user from the selected lists','Select the lists you want the user to be removed from on plan activation' );
		$settings['sublistsexpir'] = array( 'list','[Expiration] Subscribe the user to the selected lists','Select the lists you want the user to be subscribed to on plan expiration' );
		$settings['unsublistsexpir'] = array( 'list','[Expiration] Remove the user from the selected lists','Select the lists you want the user to be removed from on plan expiration' );
		$settings['sublistspreexpir'] = array( 'list','[pre-Expiration] Subscribe the user to the selected lists','Select the lists you want the user to be subscribed to on plan pre-expiration' );
		$settings['unsublistspreexpir'] = array( 'list','[pre-Expiration] Remove the user from the selected lists','Select the lists you want the user to be removed from on plan pre-expiration' );


		$settings['lists']['sublists']		= JHTML::_('select.genericlist',   $listsValues, 'sublists[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['sublists']) ? '' : $this->settings['sublists']);
		$settings['lists']['unsublists']	= JHTML::_('select.genericlist',   $listsValues, 'unsublists[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['unsublists']) ? '' : $this->settings['unsublists']);
		$settings['lists']['sublistsexpir']		= JHTML::_('select.genericlist',   $listsValues, 'sublistsexpir[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['sublistsexpir']) ? '' : $this->settings['sublistsexpir']);
		$settings['lists']['unsublistsexpir']	= JHTML::_('select.genericlist',   $listsValues, 'unsublistsexpir[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['unsublistsexpir']) ? '' : $this->settings['unsublistsexpir']);
		$settings['lists']['sublistspreexpir']		= JHTML::_('select.genericlist',   $listsValues, 'sublistspreexpir[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['sublistspreexpir']) ? '' : $this->settings['sublistspreexpir']);
		$settings['lists']['unsublistspreexpir']	= JHTML::_('select.genericlist',   $listsValues, 'unsublistspreexpir[]', 'multiple="multiple" class="inputbox"', 'value', 'text', empty($this->settings['unsublistspreexpir']) ? '' : $this->settings['unsublistspreexpir']);


		return $settings;
	}

	function expiration_action( $request )
	{
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php')){
			return true;
		};

		$this->handleSubscription($request->metaUser->userid,$this->settings['sublistsexpir'],$this->settings['unsublistsexpir']);
		return true;
	}

	function pre_expiration_action( $request )
	{
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php')){
			return true;
		};

		$this->handleSubscription($request->metaUser->userid,$this->settings['sublistspreexpir'],$this->settings['unsublistspreexpir']);
		return true;
	}

	function action( $request ){
		if(!include_once(rtrim(JPATH_ADMINISTRATOR,DS).DS.'components'.DS.'com_acymailing'.DS.'helpers'.DS.'helper.php')){
			return true;
		};

		$this->handleSubscription($request->metaUser->userid,$this->settings['sublists'],$this->settings['unsublists']);
		return true;
	}

	function handleSubscription($userid,$subscribe,$remove){

		//First we load the user as we will need some informations
		$db = &JFactory::getDBO();
		$user = new JTableUser( $db );
		$user->load( $userid );

		$config = acymailing::config();

		//We insert the user, that will do an update in case of the user is already inserted.
		$joomUser = null;
		$joomUser->email = trim(strip_tags($user->email));
		if(!empty($user->name)) $joomUser->name = trim(strip_tags($user->name));
		if(empty($user->block)) $joomUser->confirmed = 1;
		$joomUser->enabled = $config->get('require_confirmation',false) ? (1 - (int)$user->block) : 1;
		$joomUser->userid = $userid;

		$userClass = acymailing::get('class.subscriber');

		$userClass->checkVisitor = false;
		$userClass->sendConf = false;

		$subid = $userClass->save($joomUser);

		if(empty($subscribe) AND empty($remove)) return;

		$statusAdd = (empty($joomUser->confirmed) AND $config->get('require_confirmation',false)) ? 2 : 1;

		$newSubscription = array();
		if(!empty($subscribe)){
			foreach($subscribe as $listId){
				$newList = null;
				$newList['status'] = $statusAdd;
				$newSubscription[$listId] = $newList;
			}
		}
		if(!empty($remove)){
			foreach($remove as $listId){
				$newList = null;
				$newList['status'] = 0;
				$newSubscription[$listId] = $newList;
			}
		}

		if(empty($newSubscription)) return;

		$userClass->saveSubscription($subid,$newSubscription);

	}

}