<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingCbsubs extends JPlugin
{

	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'cbsubs');
			$this->params = new JParameter( $plugin->params );
		}
	}

 	function onAcyDisplayFilters(&$type,$context="massactions"){

		if($this->params->get('displayfilter_'.$context,true) == false) return;

		$db = JFactory::getDBO();
		$db->setQuery("SELECT `name`,`id` FROM #__cbsubs_plans ORDER BY `ordering` ASC");
		$allGroups = $db->loadObjectList();
		if(empty($allGroups)) return;

		$firstGroup = new stdClass();
		$firstGroup->name = JText::_('ACY_ALL');
		$firstGroup->id = 0;
		array_unshift($allGroups,$firstGroup);

		$type['cbsubs'] = 'CBSubs';

		$inoperator = acymailing_get('type.operatorsin');
		$inoperator->js = 'onchange="countresults(__num__)"';
		$statusCBSubs = array();
		$statusCBSubs[] = JHTML::_('select.option', '',JText::_('ALL_STATUS'));
		$statusCBSubs[] = JHTML::_('select.option', 'A','Actif');
		$statusCBSubs[] = JHTML::_('select.option', 'R','Registered Unpaid');
		$statusCBSubs[] = JHTML::_('select.option', 'X','Expired');
		$statusCBSubs[] = JHTML::_('select.option', 'C','Unsubscribed');
		$statusCBSubs[] = JHTML::_('select.option', 'U','Upgraded to other');
		$statusCBSubs[] = JHTML::_('select.option', 'I','Invalid');

		$autoRecurring = array();
		$autoRecurring[] = JHTML::_('select.option', '',JText::_('ACY_ALL'));
		$autoRecurring[] = JHTML::_('select.option', '0','Not autorecurring');
		$autoRecurring[] = JHTML::_('select.option', '1','Autorecurring without notifications');
		$autoRecurring[] = JHTML::_('select.option', '2','Autorecurring with notifications');

		$return = '<div id="filter__num__cbsubs">';
		$return .= $inoperator->display("filter[__num__][cbsubs][type]").' '.JHTML::_('select.genericlist',   $statusCBSubs, "filter[__num__][cbsubs][status]", 'class="inputbox" onchange="countresults(__num__)" size="1"').' '.JHTML::_('select.genericlist',   $allGroups, "filter[__num__][cbsubs][plan]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'name').' ';
		$return .= JHTML::_('select.genericlist',   $autoRecurring, "filter[__num__][cbsubs][autorecurring_type]", 'class="inputbox" onchange="countresults(__num__)" size="1"');
		$return .= '<br /><input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][cbsubs][subscription_date_inf]" value=""/> < '.JText::_('CREATED_DATE').' < <input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][cbsubs][subscription_date_sup]" value=""/>';
		$return .= '<br /><input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][cbsubs][expiry_date_inf]" value="'.date('Y-m-d').'"/> < '.JText::_('EXPIRY_DATE').' < <input type="text" onclick="displayDatePicker(this,event)" onchange="countresults(__num__)" name="filter[__num__][cbsubs][expiry_date_sup]" value=""/>';

		$return .= '</div>';
		return $return;
	 }

	function onAcyProcessFilterCount_cbsubs(&$query,$filter,$num){
		$this->onAcyProcessFilter_cbsubs($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());

	}

	function _makeLJ(&$filter,&$num){
	 	$db = JFactory::getDBO();
		$lj = "`#__cbsubs_subscriptions` as cbsubs$num ON cbsubs$num.`user_id` = sub.`userid`";
	 	if(!empty($filter['plan'])) $lj .= " AND cbsubs$num.`plan_id` = ".(int) $filter['plan'];
	 	if(!empty($filter['status'])) $lj .= " AND cbsubs$num.`status` = ".$db->Quote($filter['status']);
	 	if(isset($filter['autorecurring_type']) && strlen($filter['autorecurring_type']) > 0) $lj .= " AND cbsubs$num.`autorecurring_type` = ".intval($filter['autorecurring_type']);
	 	if(!empty($filter['subscription_date_inf'])){
	 		$filter['subscription_date_inf'] = acymailing_replaceDate($filter['subscription_date_inf']);
	 		if(is_numeric($filter['subscription_date_inf'])) $filter['subscription_date_inf'] = date('Y-m-d H:i',$filter['subscription_date_inf']);
	 		$lj .= " AND cbsubs$num.`subscription_date` > ".$db->Quote($filter['subscription_date_inf']);
	 	}
	 	if(!empty($filter['subscription_date_sup'])){
	 		$filter['subscription_date_sup'] = acymailing_replaceDate($filter['subscription_date_sup']);
	 		if(is_numeric($filter['subscription_date_sup'])) $filter['subscription_date_sup'] = date('Y-m-d H:i',$filter['subscription_date_sup']);
	 		$lj .= " AND cbsubs$num.`subscription_date` < ".$db->Quote($filter['subscription_date_sup']);
	 	}
	 	if(!empty($filter['expiry_date_inf'])){
	 		$filter['expiry_date_inf'] = acymailing_replaceDate($filter['expiry_date_inf']);
	 		if(is_numeric($filter['expiry_date_inf'])) $filter['expiry_date_inf'] = date('Y-m-d H:i',$filter['expiry_date_inf']);
	 		$lj .= " AND cbsubs$num.`expiry_date` > ".$db->Quote($filter['expiry_date_inf']);
	 	}
	 	if(!empty($filter['expiry_date_sup'])){
	 		$filter['expiry_date_sup'] = acymailing_replaceDate($filter['expiry_date_sup']);
	 		if(is_numeric($filter['expiry_date_sup'])) $filter['expiry_date_sup'] = date('Y-m-d H:i',$filter['expiry_date_sup']);
	 		$lj .= " AND cbsubs$num.`expiry_date` < ".$db->Quote($filter['expiry_date_sup']);
	 	}

	 	return $lj;
	}


	function onAcyProcessFilter_cbsubs(&$query,$filter,$num){
		$lj = $this->_makeLJ($filter,$num);

	 	$query->leftjoin['cbsubs_'.$num] = $lj;
	 	if($filter['type'] == 'IN') $query->where['member'] = 'sub.userid > 0';
	 	$operator = ($filter['type'] == 'IN') ? 'IS NOT NULL' : "IS NULL";
	 	$query->where[] = "cbsubs$num.`user_id` ".$operator;
	 }

}//endclass