<?php
/**
 * @copyright	Copyright (C) 2009-2016 ACYBA SAS - All rights reserved..
 * @license		GNU/GPLv3 http://www.gnu.org/licenses/gpl-3.0.html
 */
defined('_JEXEC') or die('Restricted access');

class plgAcymailingOsmembership extends JPlugin
{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'osmembership');
			$this->params = new acyParameter( $plugin->params );
		}
		$this->db = JFactory::getDBO();
		$this->component_installed = file_exists(JPATH_SITE.DS.'components'.DS.'com_osmembership');
	}

	function onAcyDisplayFilters(&$type,$context="massactions"){
		if($this->params->get('displayfilter_'.$context,true) == false || !$this->component_installed) return;

		// Plans
		$this->db->setQuery('SELECT id, title FROM `#__osmembership_plans` ORDER BY `title` ASC');
		$plans = $this->db->loadObjectList();

		if(empty($plans)) return;

		$lang = JFactory::getLanguage();
		$lang->load('com_osmembership',JPATH_SITE);

		$firstVal = new stdClass();
		$firstVal->title = JText::_('ACY_ALL');
		$firstVal->id = 0;
		array_unshift($plans,$firstVal);

		// Payments
		$this->db->setQuery('SELECT name AS id, title FROM `#__osmembership_plugins` ORDER BY `title` ASC');
		$payments = $this->db->loadObjectList();
		array_unshift($payments,$firstVal);

		// In operator
		$in = acymailing_get('type.operatorsin');
		$in->js = 'onchange="countresults(__num__)"';

		// Status
		$statuses = array();
		$statuses[] = JHTML::_('select.option', 'all',JText::_('ALL_STATUS'));
		$statuses[] = JHTML::_('select.option', '0',JText::_('OSM_PENDING'));
		$statuses[] = JHTML::_('select.option', '1',JText::_('OSM_ACTIVE'));
		$statuses[] = JHTML::_('select.option', '2',JText::_('OSM_EXPIRED'));
		$statuses[] = JHTML::_('select.option', '3',JText::_('OSM_CANCELLED_PENDING'));
		$statuses[] = JHTML::_('select.option', '4',JText::_('OSM_CANCELLED_REFUNDED'));

		$return = '<div id="filter__num__osmembership">'.$in->display("filter[__num__][osmembership][type]").' ';
		$return .= JHTML::_('select.genericlist', $plans, "filter[__num__][osmembership][plan]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'title');
		$return .= JHTML::_('select.genericlist', $payments, "filter[__num__][osmembership][payment]", 'class="inputbox" onchange="countresults(__num__)" size="1"', 'id', 'title');
		$return .= JHTML::_('select.genericlist', $statuses, "filter[__num__][osmembership][status]", 'class="inputbox" onchange="countresults(__num__)" size="1"');
		$return .= '<br /><input onclick="displayDatePicker(this,event)" type="text" onchange="countresults(__num__)" name="filter[__num__][osmembership][create_date_inf]"/> < '.JText::_('ACY_CREATED').' < <input onclick="displayDatePicker(this,event)" type="text" onchange="countresults(__num__)" name="filter[__num__][osmembership][create_date_sup]"/>';
		$return .= '<br /><input onclick="displayDatePicker(this,event)" type="text" onchange="countresults(__num__)" name="filter[__num__][osmembership][expiry_date_inf]"/> < '.JText::_('EXPIRY_DATE').' < <input onclick="displayDatePicker(this,event)" type="text" onchange="countresults(__num__)" name="filter[__num__][osmembership][expiry_date_sup]"/>';
		$return .= '</div>';

		$type['osmembership'] ='Membership Pro';
	 	return $return;
	}

	function onAcyProcessFilterCount_osmembership(&$query,$filter,$num){
		$this->onAcyProcessFilter_osmembership($query,$filter,$num);
		return JText::sprintf('SELECTED_USERS',$query->count());
	}

	function onAcyProcessFilter_osmembership(&$query,$filter,$num){
		$dateFields = array('create_date_inf', 'expiry_date_inf', 'create_date_sup', 'expiry_date_sup');
		foreach($dateFields as $oneField){
			if(empty($filter[$oneField])) continue;
	 		$filter[$oneField] = acymailing_replaceDate($filter[$oneField]);
	 		if(!is_numeric($filter[$oneField])) $filter[$oneField] = strtotime($filter[$oneField]);
	 		if(is_numeric($filter[$oneField])) $filter[$oneField] = strftime('%Y-%m-%d %H:%M:%S', $filter[$oneField]);
		}

		if(!empty($filter['plan'])) $conditions[] = 'osmembership'.$num.'.plan_id = '.intval($filter['plan']);
		if(!empty($filter['payment'])) $conditions[] = 'osmembership'.$num.'.payment_method = '.$this->db->Quote($filter['payment']);
		if(!empty($filter['create_date_inf'])) $conditions[] = 'osmembership'.$num.'.from_date > '.$this->db->Quote($filter['create_date_inf']);
		if(!empty($filter['create_date_sup'])) $conditions[] = 'osmembership'.$num.'.from_date < '.$this->db->Quote($filter['create_date_sup']);
		if(!empty($filter['expiry_date_inf'])) $conditions[] = 'osmembership'.$num.'.to_date > '.$this->db->Quote($filter['expiry_date_inf']);
		if(!empty($filter['expiry_date_sup'])) $conditions[] = 'osmembership'.$num.'.to_date < '.$this->db->Quote($filter['expiry_date_sup']);
		if($filter['status'] != 'all') $conditions[] = 'osmembership'.$num.'.published = '.intval($filter['status']);

		$conditions[] = 'sub.userid != 0';
		
	 	if($filter['type'] == 'IN'){
			$join = '#__osmembership_subscribers AS osmembership'.$num.' ON sub.userid = osmembership'.$num.'.user_id';
	 		if(!empty($conditions)) $join .= ' AND '.implode(' AND ', $conditions);
	 		$query->join['osmembership'.$num] = $join;
	 	}else{
	 		$join = 'SELECT osmembership'.$num.'.user_id FROM #__osmembership_subscribers AS osmembership'.$num;
	 		if(!empty($conditions)) $join .= ' WHERE '.implode(' AND ', $conditions);
	 		$query->where['osmembership'.$num] = 'sub.userid NOT IN ('.$join.')';
	 	}
	}
}//endclass