<?php
defined('_JEXEC') or die('Access Deny');

class plgAcymailingPlgcreuser extends JPlugin{
	function __construct(&$subject, $config){
		parent::__construct($subject, $config);

		//This is just to fix a bug with an old version of Joomla where the params were not loaded
		if(!isset($this->params)){
			$plugin = JPluginHelper::getPlugin('acymailing', 'creuser');
			$this->params = new acyParameter($plugin->params);
		}
	}

    function onAcyUserModify($subscriber){
        if($this->params->get('onmodif', 0) == 1) $this->createUser($subscriber);
    }

    function onAcyUserCreate($subscriber){
        $this->createUser($subscriber);
    }

    function createUser($subscriber){
		if(empty($subscriber->email)) return;
		$config = acymailing_config();

		if(version_compare($config->get('version'), '5.9.0', '<')) return;

		// Already a Joomla user
		if(!empty($subscriber->userid)) return;

        if($this->params->get('backend', 0) == 0 && acymailing_isAdmin()) return;
        
		// We can give the user the choice to create or not a Joomla account
		$optinField = $this->params->get('optinfield', '');
		if(!empty($optinField) && isset($subscriber->$optinField) && empty($subscriber->$optinField)) return;


		$params = JComponentHelper::getParams('com_users');
		$config = JFactory::getConfig();

		
		if(ACYMAILING_J16){
			acymailing_loadLanguageFile('com_users', JPATH_SITE);
		}else{
			acymailing_loadLanguageFile('com_user', JPATH_SITE);
		}

		$lists = $this->params->get('lists', '');
		if(!empty($lists) && strtolower($lists) != 'none'){
			$mandatoryLists = explode(',', $lists);
			$subOK = false;

			if(!empty($_REQUEST['subscription'])){
				if(strtolower($lists) == 'all'){
					$subOK = true;
				}else{
					foreach($_REQUEST['subscription'] as $onelist){
						if(in_array($onelist, $mandatoryLists)) $subOK = true;
					}
				}
			}

			if(!empty($_REQUEST['data']['listsub'])){
				foreach($_REQUEST['data']['listsub'] as $onelist => $status){
					if((strtolower($lists) == 'all' || in_array($onelist, $mandatoryLists)) && $status['status'] == 1) $subOK = true;
				}
			}

			if(!empty($_REQUEST['hiddenlists'])){
				if(strtolower($lists) == 'all'){
					$subOK = true;
				}else{
					$hiddenLists = explode(',', $_REQUEST['hiddenlists']);
					foreach($hiddenLists as $oneList){
						if(in_array($oneList, $mandatoryLists)) $subOK = true;
					}
				}
			}

			if(!$subOK) return;
		}

		$useractivation = $params->get('useractivation');
		$allowUserRegistration = $params->get('allowUserRegistration');
		if($allowUserRegistration == 0) return;

		// Generate the password
		$minimum_integers = $params->get('minimum_integers');
		$minimum_symbols = $params->get('minimum_symbols');
		$minimum_uppercase = $params->get('minimum_uppercase');
		$length = 8;
		if(ACYMAILING_J30 && $params->get('minimum_length') > 8) $length = $params->get('minimum_length');
		$tryCount = 0;
		do{
			$password = acymailing_generatePassword($length);
			$tryCount++;
			//Could happen if the admin selected 90 as min integers and min length = 9, in this case we will nether generate a satisfying password
			if($tryCount > 50) break;
		}while(ACYMAILING_J30 && ((!empty($minimum_integers) && preg_match_all("/[0-9]/", $password, $out) < $minimum_integers) || (!empty($minimum_symbols) && preg_match_all("/[a-z]/", $password, $out) < $minimum_symbols) || (!empty($minimum_uppercase) && preg_match_all("/[A-Z]/", $password, $out) < $minimum_uppercase)));

		$data = array("name" => (!empty($subscriber->name) ? $subscriber->name : $subscriber->email), "username" => $subscriber->email, "password" => $password, "password2" => $password, "email" => $subscriber->email, "block" => 0);

		$usertype = $params->get('new_usertype');
		$groupoption = $this->params->get('group', '');
		if(ACYMAILING_J16) $groupoption = intval($groupoption);
		if(!empty($groupoption)) $usertype = $groupoption;
		if(ACYMAILING_J16){
			$data['groups'] = array($usertype);
		}else{
			$acl =& JFactory::getACL();
			$data['gid'] = $acl->get_group_id('', $usertype);
			$data['usertype'] = $usertype;
		}

		$user = new JUser();

		// Check if the user needs to activate his account.
		if($useractivation == 1 || $useractivation == 2){
			if(ACYMAILING_J16){
				$data['activation'] = JApplication::getHash(acymailing_generatePassword());
			}else{
				$data['activation'] = JUtility::getHash(acymailing_generatePassword());
			}
			$data['block'] = 1;
		}

		// Write to database
		if(!$user->bind($data)){
			acymailing_enqueueMessage(acymailing_translation_sprintf('COM_USERS_REGISTRATION_BIND_FAILED', $user->getError()), 'error');
			return false;
		}

		// Store the data.
		if(!$user->save()){
			acymailing_enqueueMessage($user->getError(), 'error');
			return false;
		}

		$subscriber->userid = $user->id;

		$subClass = acymailing_get('class.subscriber');
		$subClass->checkVisitor = false;
		$subClass->sendConf = false;
		$subClass->save($subscriber);

		// Compile the notification mail values.
		$data = $user->getProperties();
		$data['fromname'] = $config->get('fromname');
		$data['mailfrom'] = $config->get('mailfrom');
		$data['sitename'] = $config->get('sitename');
		$data['siteurl'] = str_replace('/administrator', '', acymailing_baseURI());

		// Handle account activation/confirmation emails.

		$emailSubject = acymailing_translation_sprintf((ACYMAILING_J16 ? 'COM_USERS_EMAIL_ACCOUNT_DETAILS' : 'ACCOUNT DETAILS FOR'), $data['name'], $data['sitename']);
		if($useractivation == 2 || $useractivation == 1){
			$base = acymailing_currentURL();
			$activationLink = ACYMAILING_J16 ? 'index.php?option=com_users&task=registration.activate&token=' : 'index.php?option=com_user&task=activate&activation=';

			if($useractivation == 2){
				//Only for J2.5 and J3
				$emailBody = acymailing_translation_sprintf('COM_USERS_EMAIL_REGISTERED_WITH_ADMIN_ACTIVATION_BODY', $data['name'], $data['sitename'], $data['siteurl'].$activationLink.$data['activation'], $data['siteurl'], $data['username'], $data['password_clear']);
			}else{
				$activationMessage = ACYMAILING_J16 ? 'COM_USERS_EMAIL_REGISTERED_WITH_ACTIVATION_BODY' : 'SEND_MSG_ACTIVATE';
				$emailBody = acymailing_translation_sprintf($activationMessage, $data['name'], $data['sitename'], $data['siteurl'].$activationLink.$data['activation'], $data['siteurl'], $data['username'], $data['password_clear']);
			}

			$data['activate'] = $base.acymailing_route($activationLink.$data['activation'], false);
		}else{
			if(ACYMAILING_J16){
				$emailBody = acymailing_translation_sprintf('COM_USERS_EMAIL_REGISTERED_BODY', $data['name'], $data['sitename'], $data['siteurl'], $data['username'], $data['password_clear']);
			}else{
				$emailBody = acymailing_translation_sprintf('SEND_MSG', $data['name'], $data['sitename'], $data['siteurl']);
			}
		}

		// Fetch the mail object - A reference to the global mail object (JMail) is fetched through the JFactory object. This is the object creating our mail.
		$mailer = JFactory::getMailer();
		/* Set a sender - The sender of an email is set with setSender. The function takes an array with an email address and a name as an argument.
		We fetch the site's email address and name from the global configuration.
		This info is set in Global Configuration -> Server -> Mail Settings. */
		$sender = array($config->get('mailfrom'), $config->get('fromname'));
		$mailer->setSender($sender);
		/* Recipient - You set the recipient of an email with the function addRecipient.
		To set the email address to the currently logged in user, we fetch it from the user object. */
		$mailer->addRecipient($subscriber->email);
		/* Set the subject and the body. The easy way to create an email body is as a string with plain text.
		You can also attach a file with addAttachment. It takes a single file name or an array of file names as argument.*/
		$mailer->setSubject($emailSubject);
		$mailer->setBody($emailBody);
		// Send the mail - It is sent with the function Send. It returns true on success or a JError object.
		$send = $mailer->Send();
		if($send !== true){
			acymailing_enqueueMessage(acymailing_translation((ACYMAILING_J16 ? 'COM_USERS_MAIL_SEND_FAILURE_SUBJECT' : 'ERROR_SENDING_CONFIRMATION_EMAIL')), 'error');
		}else acymailing_enqueueMessage(acymailing_translation('ACY_SENT_EMAILS'), ACYMAILING_J16 ? 'message' : 'success');
	}
}//endclass